diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/post.c tin-2.6.5/src/post.c
--- tin-2.6.4/src/post.c	2024-12-22 18:22:18.000000000 +0100
+++ tin-2.6.5/src/post.c	2025-12-08 20:32:45.691392557 +0100
@@ -3,10 +3,10 @@
  *  Module    : post.c
  *  Author    : I. Lea
  *  Created   : 1991-04-01
- *  Updated   : 2024-12-22
+ *  Updated   : 2025-12-08
  *  Notes     : mail/post/replyto/followup/repost & cancel articles
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -73,7 +73,7 @@
 #		define ADD_CAN_LOCK(id) { \
 			if (tinrc.cancel_lock_algo) { \
 				char lock[1024]; \
-				char *lptr = (char *) 0; \
+				char *lptr; \
 				lock[0] = '\0'; \
 				if ((lptr = build_canlock(id, get_secret())) != NULL) { \
 					STRCPY(lock, lptr); \
@@ -94,7 +94,7 @@
 /* gee! ugly hack - but works */
 #	define ADD_MSG_ID_HEADER()	{ \
 		char mid[NNTP_STRLEN]; \
-		const char *mptr = (const char *) 0; \
+		const char *mptr; \
 		mid[0] = '\0'; \
 		if ((mptr = build_messageid()) != NULL) { \
 			STRCPY(mid, mptr); \
@@ -119,9 +119,9 @@
 
 static int start_line_offset = 1;		/* used by invoke_editor for line no. */
 
-char bug_addr[LEN];			/* address to add send bug reports to */
-static char my_distribution[LEN];		/* Distribution: */
-static char reply_to[LEN];		/* Reply-To: address */
+char bug_addr[HEADER_LEN];			/* address to add send bug reports to */
+static char my_distribution[HEADER_LEN];		/* Distribution: */
+static char reply_to[HEADER_LEN];		/* Reply-To: address */
 
 static struct msg_header {
 	char *name;
@@ -136,6 +136,7 @@ static t_posted *post_hist_list;
  */
 static FILE *create_mail_headers(char *filename, size_t filename_len, const char *suffix, const char *to, const char *subject, struct t_header *extra_hdrs);
 static char **build_nglist(char *ngs_list, int *ngcnt);
+static char *find_distribution(const char *ngs_list);
 static char **split_address_list(const char *addresses, unsigned int *cnt);
 static int add_mail_quote(FILE *fp, int respnum);
 static int append_mail(const char *the_article, const char *addr, const char *the_mailbox);
@@ -169,7 +170,7 @@ static void add_headers(const char *infi
 static void build_post_hist_line(int i);
 static void draw_post_hist_arrow(void);
 static void appendid(char **where, const char **what);
-static void find_reply_to_addr(char *from_addr, t_bool parse, struct t_header *hdr);
+static void find_reply_to_addr(char *from_addr, t_bool parse, const struct t_header *hdr);
 static void free_post_hist_list(void);
 static void join_references(char *buffer, const char *oldrefs, const char *newref);
 static void msg_add_header(const char *name, const char *text);
@@ -284,7 +285,8 @@ void
 init_postinfo(
 	void)
 {
-	char *ptr;
+	const char *ptr;
+	size_t w;
 
 	/*
 	 * check environment for REPLYTO
@@ -299,6 +301,10 @@ init_postinfo(
 	my_distribution[0] = '\0';
 	if ((ptr = getenv("DISTRIBUTION")) != NULL && *ptr)
 		my_strncpy(my_distribution, ptr, sizeof(my_distribution) - 1);
+	strip_double_ngs(my_distribution);
+	w = strlen(my_distribution);
+	while (w && my_distribution[--w] == ',')
+		my_distribution[w] = '\0';
 }
 
 
@@ -472,7 +478,7 @@ static void
 show_post_hist_page(
 	void)
 {
-	int i;
+	int i, prev_mark_offset = mark_offset;
 
 	signal_context = cPOSTED;
 	currmenu = &phmenu;
@@ -491,6 +497,7 @@ show_post_hist_page(
 	show_mini_help(POSTED_LEVEL);
 
 	draw_post_hist_arrow();
+	mark_offset = prev_mark_offset;
 }
 
 
@@ -603,7 +610,8 @@ post_hist_page(
 
 			case GLOBAL_TOGGLE_INFO_LAST_LINE:
 				tinrc.info_in_last_line = bool_not(tinrc.info_in_last_line);
-				show_post_hist_page();
+				clear_message();
+				draw_post_hist_arrow();
 				break;
 
 			case GLOBAL_TOGGLE_INVERSE_VIDEO:
@@ -677,7 +685,7 @@ draw_post_hist_arrow(
 	if (tinrc.info_in_last_line) {
 		t_posted *lptr = find_post_hist(phmenu.curr);
 
-		if (*lptr->mid)
+		if (lptr->mid)
 			info_message("%s", lptr->mid);
 	} else if (phmenu.curr == phmenu.max - 1)
 		info_message(_(txt_end_of_posted));
@@ -701,7 +709,7 @@ static void
 build_post_hist_line(
 	int i)
 {
-	char *sptr;
+	char *sptr, *to = NULL;
 	char *tmp = NULL;
 	int group_len = cCOLS / 5;
 	t_posted *lptr;
@@ -737,6 +745,7 @@ build_post_hist_line(
 		}
 		free(wtmp);
 	}
+	to = spart(tmp ? tmp : " ", group_len, TRUE);
 #else
 	if (!strchr(lptr->group, '@') && tinrc.abbreviate_groupname)
 		tmp = abbr_groupname(lptr->group, group_len);
@@ -744,19 +753,25 @@ build_post_hist_line(
 		tmp = my_strdup(lptr->group);
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 
+	if (!to) {
+		to = my_malloc(group_len + 1);
+		snprintf(to, group_len + 1, "%-*.*s", group_len, group_len, tmp ? tmp : " ");
+	}
+
 #if 1
-	snprintf(sptr, len, "  %s  %8s  %c  %-*.*s  \"%s\"", tin_ltoa(i + 1, 4),
+	snprintf(sptr, len, "  %s  %8s  %c  %s  \"%s\"", tin_ltoa(i + 1, 4),
 			lptr->date, lptr->action,
-			group_len, group_len, BlankIfNull(tmp),
-			lptr->subj);
+			to,
+			BlankIfNull(lptr->subj));
 #else
 	/* also show MID */
-	snprintf(sptr, len, "  %s  %8s  %c  %-*.*s  \"%s\" %s", tin_ltoa(i + 1, 4),
+	snprintf(sptr, len, "  %s  %8s  %c  %s  \"%s\" %s", tin_ltoa(i + 1, 4),
 			lptr->date, lptr->action,
-			group_len, group_len, BlankIfNull(tmp),
-			lptr->subj,
-			lptr->mid);
+			to,
+			BlankIfNull(lptr->subj),
+			BlankIfNull(lptr->mid));
 #endif /* 1 */
+	free(to);
 
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 	if ((wtmp = char2wchar_t(sptr)) != NULL) {
@@ -798,7 +813,7 @@ process_post_hist(
 		ret = LOOKUP_REPLY;
 #ifdef NNTP_ABLE
 	else if (read_news_via_nntp && !read_saved_news) {
-			ret = show_article_by_msgid(lptr->mid);
+		ret = show_article_by_msgid(lptr->mid);
 	}
 #endif /* NNTP_ABLE */
 	/*
@@ -815,7 +830,7 @@ process_post_hist(
 			if ((msgid = find_msgid(lptr->mid)) != NULL) {
 				if (msgid->article != ART_UNAVAILABLE) {
 					if (show_page(curr_group, msgid->article, NULL))
-							ret = LOOKUP_OK;
+						ret = LOOKUP_OK;
 				}
 			}
 		} else
@@ -834,8 +849,9 @@ build_post_hist_list(
 	char *buf;
 	int count = 0;
 	int err = 0;
-	long fpos = 0;
+	long fpos = 0L;
 	size_t j, k, n, buflen = LEN;
+	t_bool ng_list = FALSE;
 	t_posted *posted = NULL;
 
 	if ((fp = tin_fopen(posted_info_file, "r")) == NULL) {
@@ -854,6 +870,7 @@ build_post_hist_list(
 			err = E2BIG; /* EMSGSIZE? EOVERFLOW? EFBIG? */
 			break;
 		}
+
 		if (strlen(buf) == buflen - 1 && buf[buflen - 1] != '\n') {
 			buflen <<= 1;
 			buf = my_realloc(buf, buflen);
@@ -861,9 +878,9 @@ build_post_hist_list(
 				err = errno;
 				break;
 			}
-
 			continue;
 		}
+
 		if ((fpos = ftell(fp)) == -1) {
 			err = errno;
 			break;
@@ -881,6 +898,10 @@ build_post_hist_list(
 			post_hist_list = posted;
 		}
 
+		posted->group = NULL;
+		posted->subj = NULL;
+		posted->mid = NULL;
+
 		n = 0;
 		q = my_strdup(buf);
 		if (tin_strtok(q, "|") != NULL) {
@@ -916,35 +937,35 @@ build_post_hist_list(
 		/* TODO:
 		 * - '|' in local-parts of mail addresses will confuse the code
 		 */
-		for (k = 0; buf[j] != '|' && buf[j] != ','; j++) {
-			if (k < sizeof(posted->group) - 1)
-				posted->group[k++] = buf[j];
-		}
+		p = &buf[j];
+		for (k = 0; buf[j] != '|' && buf[j] != ','; j++, k++)
+			;
+
 		if (buf[j] == ',') {
+			ng_list = TRUE;
+			buf[j++] = '\0';
 			while (buf[j] != '|' && buf[j] != '\n')
 				++j;
+			k += 4; /* ",..." */
+		}
 
-			if (k > sizeof(posted->group) - 5)
-				k = sizeof(posted->group) - 5;
+		posted->group = my_calloc(1, k + 1);
+		strncpy(posted->group, p, k);
 
-			posted->group[k++] = ',';
-			posted->group[k++] = '.';
-			posted->group[k++] = '.';
-			posted->group[k++] = '.';
+		if (ng_list) {
+			strcat(posted->group, ",...");
+			ng_list = FALSE;
 		}
-		posted->group[k] = '\0';
 
-		++j;
+		p = &buf[++j];
 
-		p = buf;
 		while ((q = strstr(p, "|<")) != NULL)
 			p = ++q;
 
-		if (strlen(p) >= 4 && *p == '<' && strlen(p) < sizeof(posted->mid) - 1) { /* <@> */
+		if (strlen(p) >= 4 && *p == '<') { /* <@> */
 			t_bool invalid = FALSE;
 			t_bool has_at = FALSE;
 
-			k = 0;
 			for (q = p; *q != '\n' && !invalid; q++) {
 				if (*q < 33 || !isascii((unsigned char) *q)) {
 					invalid = TRUE;
@@ -952,23 +973,24 @@ build_post_hist_list(
 				}
 				if (*q == '@')
 					has_at = TRUE;
-
-				posted->mid[k++] = *q;
 			}
 
 			if (*q != '\n' || *(q - 1) != '>')
 				invalid = TRUE;
 
 			if (!invalid && has_at) {
-				posted->mid[k] = '\0';
-				*(p - 1) = '\n'; /* so it does not end up in subj */
-			} else
-				posted->mid[0] = '\0';
+				*q = '\0'; /* replace '\n' */
+				*(p - 1) = '\0'; /* so it does not end up in subj */
+				posted->mid = my_strdup(p);
+			}
 		}
 
 		if (p == buf || p == buf + j) /* subject looks like id and no id logged or no id given, clear id */
-			posted->mid[0] = '\0';
-		my_strncpy(posted->subj, buf + j, sizeof(posted->subj) - 1);
+			FreeAndNull(posted->mid);
+		p = buf + j;
+		if (*(p + strlen(p) - 1) == '\n')
+			*(p + strlen(p) - 1) = '\0';
+		posted->subj = my_strdup(p);
 		++count;
 	}
 
@@ -996,6 +1018,9 @@ free_post_hist_list(
 
 	for (p = post_hist_list; p != NULL; p = q) {
 		q = p->next;
+		FreeIfNeeded(p->group);
+		FreeIfNeeded(p->subj);
+		FreeIfNeeded(p->mid);
 		free(p);
 	}
 	post_hist_list = NULL;
@@ -1126,7 +1151,7 @@ append_mail(
 			(void) time(&epoch);
 			fprintf(fp_out, "From %s %s\n", addr, BlankIfNull(str_trim(ctime(&epoch))));
 		}
-		while (fgets(buf, (int) sizeof(buf), fp_in) != NULL) {
+		while (fgets(buf, sizeof(buf), fp_in) != NULL) {
 			if (!mmdf) { /* moboxo/mboxrd style From_ quoting required */
 				/*
 				 * TODO: add Content-Length: header when using MBOXO
@@ -1215,43 +1240,44 @@ append_mail(
 #define CA_ERROR_BAD_MESSAGE_ID            0x0002000
 #define CA_ERROR_BAD_DATE                  0x0004000
 #define CA_ERROR_BAD_EXPIRES               0x0008000
-#define CA_ERROR_NEWSGROUPS_NOT_7BIT       0x0010000
-#define CA_ERROR_FOLLOWUP_TO_NOT_7BIT      0x0020000
-#define CA_ERROR_DISTRIBUTIOIN_NOT_7BIT    0x0040000
-#define CA_ERROR_NEWSGROUPS_POSTER         0x0080000
-#define CA_ERROR_FOLLOWUP_TO_POSTER        0x0100000
-#define CA_ERROR_NO_RECIPIENT              0x0200000
-#define CA_ERROR_EMPTY_BODY                0x0400000
+#define CA_ERROR_NEWSGROUPS_POSTER         0x0010000
+#define CA_ERROR_FOLLOWUP_TO_POSTER        0x0020000
+#define CA_ERROR_NO_RECIPIENT              0x0040000
+#define CA_ERROR_EMPTY_BODY                0x0080000
 #ifndef ALLOW_FWS_IN_NEWSGROUPLIST
-#	define CA_ERROR_SPACE_IN_NEWSGROUPS    0x0800000
-#	define CA_ERROR_NEWLINE_IN_NEWSGROUPS  0x1000000
-#	define CA_ERROR_SPACE_IN_FOLLOWUP_TO   0x2000000
-#	define CA_ERROR_NEWLINE_IN_FOLLOWUP_TO 0x4000000
+#	define CA_ERROR_SPACE_IN_NEWSGROUPS    0x0100000
+#	define CA_ERROR_NEWLINE_IN_NEWSGROUPS  0x0200000
+#	define CA_ERROR_SPACE_IN_FOLLOWUP_TO   0x0400000
+#	define CA_ERROR_NEWLINE_IN_FOLLOWUP_TO 0x0800000
 #endif /* !ALLOW_FWS_IN_NEWSGROUPLIST */
-#define CA_ERROR_DISTRIBUTION_ALL          0x8000000
+#define CA_ERROR_DISTRIBUTION_ALL          0x1000000
+
+#define CA_WARNING_SPACES_ONLY_SUBJECT       0x000001
+#define CA_WARNING_RE_WITHOUT_REFERENCES     0x000002
+#define CA_WARNING_REFERENCES_WITHOUT_RE     0x000004
+#define CA_WARNING_MULTIPLE_SIGDASHES        0x000008
+#define CA_WARNING_WRONG_SIGDASHES           0x000010
+#define CA_WARNING_LONG_SIGNATURE            0x000020
+#define CA_WARNING_ENCODING_EXTERNAL_INEWS   0x000040
+#define CA_WARNING_NEWSGROUPS_EXAMPLE        0x000080
+#define CA_WARNING_FOLLOWUP_TO_EXAMPLE       0x000100
+#define CA_WARNING_DISTRIBUTION_WORLD        0x000200
+#define CA_WARNING_MULTI_ADDRESSES_REPLYTO   0x000400
+#define CA_WARNING_MULTI_ADDRESSES_FROM      0x000800
+#define CA_WARNING_MULTI_ADDRESSES_TO        0x001000
+#define CA_WARNING_RE_ONLY_SUBJECT           0x002000
+#define CA_WARNING_NEWSGROUPS_NOT_7BIT       0x004000
+#define CA_WARNING_FOLLOWUP_TO_NOT_7BIT      0x008000
+#define CA_WARNING_DISTRIBUTION_NOT_7BIT     0x010000
 
-#define CA_WARNING_SPACES_ONLY_SUBJECT       0x00001
-#define CA_WARNING_RE_WITHOUT_REFERENCES     0x00002
-#define CA_WARNING_REFERENCES_WITHOUT_RE     0x00004
-#define CA_WARNING_MULTIPLE_SIGDASHES        0x00008
-#define CA_WARNING_WRONG_SIGDASHES           0x00010
-#define CA_WARNING_LONG_SIGNATURE            0x00020
-#define CA_WARNING_ENCODING_EXTERNAL_INEWS   0x00040
-#define CA_WARNING_NEWSGROUPS_EXAMPLE        0x00080
-#define CA_WARNING_FOLLOWUP_TO_EXAMPLE       0x00100
-#define CA_WARNING_DISTRIBUTION_WORLD        0x00200
-#define CA_WARNING_MULTI_ADDRESSES_REPLYTO   0x00400
-#define CA_WARNING_MULTI_ADDRESSES_FROM      0x00800
-#define CA_WARNING_MULTI_ADDRESSES_TO        0x01000
-#define CA_WARNING_RE_ONLY_SUBJECT           0x02000
 #ifdef CHARSET_CONVERSION
-#	define CA_WARNING_CHARSET_CONVERSION     0x04000
+#	define CA_WARNING_CHARSET_CONVERSION     0x020000
 #endif /* CHARSET_CONVERSION */
 #ifdef ALLOW_FWS_IN_NEWSGROUPLIST
-#	define CA_WARNING_SPACE_IN_NEWSGROUPS    0x08000
-#	define CA_WARNING_NEWLINE_IN_NEWSGROUPS  0x10000
-#	define CA_WARNING_SPACE_IN_FOLLOWUP_TO   0x20000
-#	define CA_WARNING_NEWLINE_IN_FOLLOWUP_TO 0x40000
+#	define CA_WARNING_SPACE_IN_NEWSGROUPS    0x040000
+#	define CA_WARNING_NEWLINE_IN_NEWSGROUPS  0x080000
+#	define CA_WARNING_SPACE_IN_FOLLOWUP_TO   0x100000
+#	define CA_WARNING_NEWLINE_IN_FOLLOWUP_TO 0x200000
 #endif /* ALLOW_FWS_IN_NEWSGROUPLIST */
 
 /*
@@ -1278,6 +1304,7 @@ check_article_to_be_posted(
 	char **followupto = NULL;
 	char *line, *cp, *cp2, *hp;
 	char *to = NULL;
+	char *dist = NULL;
 	char references[HEADER_LEN];
 	char subject[HEADER_LEN];
 	int cnt = 0;
@@ -1338,7 +1365,7 @@ check_article_to_be_posted(
 	enc = *c_group ? (*c_group)->attribute->post_mime_encoding : tinrc.post_mime_encoding;
 
 	oldraw = RawState();	/* save state */
-	subject[0] = '\0';
+	*subject = '\0';
 
 	/* check the header of the article */
 	setup_check_article_screen(&init);
@@ -1346,7 +1373,7 @@ check_article_to_be_posted(
 	while ((line = tin_fgets(fp, TRUE)) != NULL) {
 		++cnt;
 		contains_8bit = FALSE; /* in header we need to check line wise */
-		if (!end_of_header && !strlen(line)) { /* end of header reached */
+		if (!end_of_header && !*line) { /* end of header reached */
 			if (cnt == 1)
 				errors_catbp |= CA_ERROR_HEADER_LINE_BLANK;
 			end_of_header = TRUE;
@@ -1367,9 +1394,9 @@ check_article_to_be_posted(
 		{
 			if (strlen(line) > IMF_LINE_LEN) {
 #ifdef MIME_BREAK_LONG_LINES
-				my_fprintf(stderr, _(txt_error_should_be_folded), cnt, IMF_LINE_LEN);
+				my_fprintf(stderr, P_(txt_error_should_be_folded_sp[0], txt_error_should_be_folded_sp[1], IMF_LINE_LEN), cnt, IMF_LINE_LEN);
 #else
-				my_fprintf(stderr, _(txt_error_should_be_shortened), cnt, IMF_LINE_LEN);
+				my_fprintf(stderr, P_(txt_error_should_be_shortened_sp[0], txt_error_should_be_shortened_sp[1], IMF_LINE_LEN), cnt, IMF_LINE_LEN);
 #endif /* MIME_BREAK_LONG_LINES */
 				my_fflush(stderr);
 				++warnings;
@@ -1452,7 +1479,7 @@ check_article_to_be_posted(
 		if (cp - line == 8 && !strncasecmp(line, "Approved", 8)) {
 			if (tinrc.beginner_level) {
 				/* StartInverse(); */
-				my_fprintf(stderr, "%s", _(txt_error_approved)); /* this is only a Warning: */
+				my_fprintf(stderr, "%s", _(txt_warn_approved));
 				/* EndInverse(); */
 				my_fflush(stderr);
 #ifdef HAVE_FASCIST_NEWSADMIN
@@ -1558,7 +1585,7 @@ check_article_to_be_posted(
 			for (hp = line + 11; *hp == ' '; hp++)
 				;
 
-			if (strchr(hp, ' ') || strchr(hp, '\t')) {
+			if (strpbrk(hp, " \t")) {
 #ifdef ALLOW_FWS_IN_NEWSGROUPLIST
 				warnings_catbp |= CA_WARNING_SPACE_IN_NEWSGROUPS;
 #else
@@ -1584,7 +1611,7 @@ check_article_to_be_posted(
 			else {
 				for (hp = line + 11; *hp; hp++) {
 					if (!isascii((unsigned char) *hp)) {
-						errors_catbp |= CA_ERROR_NEWSGROUPS_NOT_7BIT;
+						warnings_catbp |= CA_WARNING_NEWSGROUPS_NOT_7BIT;
 						break;
 					}
 				}
@@ -1624,11 +1651,10 @@ check_article_to_be_posted(
 		}
 
 		if (cp - line == 12 && !strncasecmp(line, "Distribution", 12)) {
-			char *dist;
-
+			FreeIfNeeded(dist);
 			for (hp = line + 13; *hp; hp++) {
 				if (!isascii((unsigned char) *hp)) {
-					errors_catbp |= CA_ERROR_DISTRIBUTIOIN_NOT_7BIT;
+					warnings_catbp |= CA_WARNING_DISTRIBUTION_NOT_7BIT;
 					break;
 				}
 			}
@@ -1654,10 +1680,11 @@ check_article_to_be_posted(
 						warnings_catbp |= CA_WARNING_DISTRIBUTION_WORLD;
 
 #if 0 /* TODO */
-					if (strlen(hp) < 2)
+					i = strlen(hp);
+					if (i < 2)
 						warnings_catbp |= CA_WARNING_DISTRIBUTION_SHORT;
-					if (strlen(hp) == 2) {
-						if (!isalpha(*hp) || !isalpha(*hp + 1))
+					else {
+						if (i == 2 && !isalpha((unsigned char) *hp) || !isalpha((unsigned char) *hp + 1))
 							/*
 							 * simplified check for two-letter country codes
 							 * ISO-3166-1, what about gnksa_country_codes[]?
@@ -1670,7 +1697,7 @@ check_article_to_be_posted(
 					 * warn or error?
 					 * do in !isacii() check above?
 					 */
-					while (isalnum(*hp) || *hp == '+' || *hp == '_' || *hp == '-')
+					while (isalnum((unsigned char) *hp) || *hp == '+' || *hp == '_' || *hp == '-')
 						++hp;
 					if (*hp != '\0')
 						warnings_catbp |= CA_WARNING_DISTRIBUTION_CHAR;
@@ -1679,6 +1706,7 @@ check_article_to_be_posted(
 				} while ((hp = strtok(NULL, ", \t\n")) != NULL);
 			}
 			free(cp2);
+			dist = my_strdup(line + 14);
 			continue;
 		}
 
@@ -1688,7 +1716,7 @@ check_article_to_be_posted(
 				;
 			if (*hp) /* Followup-To not empty */
 				++found_followup_to_lines;
-			if (strchr(hp, ' ') || strchr(hp, '\t')) {
+			if (strpbrk(hp, " \t")) {
 #ifdef ALLOW_FWS_IN_NEWSGROUPLIST
 				warnings_catbp |= CA_WARNING_SPACE_IN_FOLLOWUP_TO;
 #else
@@ -1711,7 +1739,7 @@ check_article_to_be_posted(
 				(void) stripped_double_ngs(followupto, &ftngcnt);
 				for (hp = line + 12; *hp; hp++) {
 					if (!isascii((unsigned char) *hp)) {
-						errors_catbp |= CA_ERROR_FOLLOWUP_TO_NOT_7BIT;
+						warnings_catbp |= CA_WARNING_FOLLOWUP_TO_NOT_7BIT;
 						break;
 					}
 				}
@@ -1742,7 +1770,6 @@ check_article_to_be_posted(
 						 *       uppercase letters
 						 *       all digit component
 						 */
-
 					} while ((hp = strtok(NULL, ",")) != NULL);
 				}
 				free(cp2);
@@ -1769,22 +1796,13 @@ check_article_to_be_posted(
 		}
 		free(cp2);
 
-		if (!(warnings_catbp & CA_WARNING_RE_WITHOUT_REFERENCES)) {
-			/*
-			 * Warn if there are References: but no "Re: " at the beginning
-			 * of and no "(was:" in the Subject.
-			 */
-			if (saw_references && strncmp(subject, "Re: ", 4)) {
-				t_bool was_found = FALSE;
-
-				cp2 = subject;
-				while (!was_found && (cp2 = strchr(cp2, '(')))
-				was_found = (STRNCMPEQ(++cp2, "was:", 4));
+		if (!(warnings_catbp & CA_WARNING_RE_WITHOUT_REFERENCES) && saw_references && strncmp(subject, "Re: ", 4) && !strstr(subject, "(was:"))
+			warnings_catbp |= CA_WARNING_REFERENCES_WITHOUT_RE;
 
-				if (!was_found)
-					warnings_catbp |= CA_WARNING_REFERENCES_WITHOUT_RE;
-			}
-		}
+		/*
+		 * TODO: - warn if subject starts with "(was:"
+		 *       - warn if subject starts with "Re:" and contains "(was:"
+		 */
 	}
 
 	if (!found_from_lines)
@@ -1876,6 +1894,13 @@ check_article_to_be_posted(
 					col += 8 - (col % 8);
 					++cp;
 				} else {
+					char *tcp = strunc(cp, cCOLS - 1);
+
+					/*
+					 * TODO: convert the unprintables to hex ("0X%.2X ")
+					 * or the like (we use octal in draw_pager_line())
+					 * before strunc()?
+					 */
 #if defined(MULTIBYTE_ABLE) && !defined(NO_LOCALE)
 					if ((num_bytes = mbtowc(&wc, cp, MB_CUR_MAX)) != -1) {
 						if (!contains_8bit && (num_bytes > 1 || !isascii((unsigned char) *cp)))
@@ -1885,7 +1910,7 @@ check_article_to_be_posted(
 						else {
 							if (seen != cnt) { /* warn just once per line */
 								seen = cnt;
-								my_fprintf(stderr, _(txt_warn_unprintable_char), cnt, strunc(cp, cCOLS - 1));
+								my_fprintf(stderr, _(txt_warn_unprintable_char), cnt, tcp);
 								++warnings;
 							}
 							++col;
@@ -1894,7 +1919,7 @@ check_article_to_be_posted(
 					} else {
 						if (seen != cnt) { /* warn just once per line */
 							seen = cnt;
-							my_fprintf(stderr, _(txt_warn_unprintable_char), cnt, strunc(cp, cCOLS - 1));
+							my_fprintf(stderr, _(txt_warn_unprintable_char), cnt, tcp);
 							++warnings;
 						}
 						++cp;
@@ -1905,12 +1930,13 @@ check_article_to_be_posted(
 						contains_8bit = TRUE;
 					if (!my_isprint((unsigned char) *cp) && seen != cnt) { /* warn just once per line */
 						seen = cnt;
-						my_fprintf(stderr, _(txt_warn_unprintable_char), cnt, strunc(cp, cCOLS - 1));
+						my_fprintf(stderr, _(txt_warn_unprintable_char), cnt, tcp);
 						++warnings;
 					}
 					++cp;
 					++col;
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
+					free(tcp);
 				}
 			}
 			if (seen) /* any unprintable char errors? */
@@ -1919,7 +1945,7 @@ check_article_to_be_posted(
 		if (!got_long_line && col > MAX_COL) {
 			char *m = strunc(line, MAX_COL - 1);
 
-			my_fprintf(stderr, _(txt_warn_art_line_too_long), MAX_COL, cnt, m);
+			my_fprintf(stderr, P_(txt_warn_art_line_too_long_sp[0], txt_warn_art_line_too_long_sp[1], MAX_COL), MAX_COL, cnt, m);
 			my_fflush(stderr);
 			free(m);
 			got_long_line = TRUE;
@@ -1938,14 +1964,14 @@ check_article_to_be_posted(
 #ifdef MIME_BREAK_LONG_LINES
 		if (contains_8bit) {
 			if (enc != MIME_ENCODING_QP)
-				my_fprintf(stderr, _(txt_warn_long_line_not_qp), must_break_line, IMF_LINE_LEN, content_encodings[ENCODING_QP], content_encodings[ENCODING_BASE64]);
+				my_fprintf(stderr, P_(txt_warn_long_line_not_qp_sp[0], txt_warn_long_line_not_qp_sp[1], IMF_LINE_LEN), must_break_line, IMF_LINE_LEN, content_encodings[ENCODING_QP], content_encodings[ENCODING_BASE64]);
 		} else
 #endif /* MIME_BREAK_LONG_LINES */
 		{
 			if (enc == MIME_ENCODING_QP)
-				my_fprintf(stderr, _(txt_warn_long_line_not_break), must_break_line, IMF_LINE_LEN, content_encodings[ENCODING_QP]);
+				my_fprintf(stderr, P_(txt_warn_long_line_not_break_sp[0], txt_warn_long_line_not_break_sp[1], IMF_LINE_LEN), must_break_line, IMF_LINE_LEN, content_encodings[ENCODING_QP]);
 			else
-				my_fprintf(stderr, _(txt_warn_long_line_not_base), must_break_line, IMF_LINE_LEN, content_encodings[ENCODING_BASE64]);
+				my_fprintf(stderr, P_(txt_warn_long_line_not_base_sp[0], txt_warn_long_line_not_base_sp[1], IMF_LINE_LEN), must_break_line, IMF_LINE_LEN, content_encodings[ENCODING_BASE64]);
 		}
 		my_fflush(stderr);
 		++warnings;
@@ -2042,29 +2068,29 @@ check_article_to_be_posted(
 			my_fprintf(stderr, _(txt_error_header_line_missing), "From");
 		else {
 			if (errors_catbp & CA_ERROR_DUPLICATED_FROM)
-				my_fprintf(stderr, _(txt_error_header_duplicate), found_from_lines, "From");
+				my_fprintf(stderr, P_(txt_error_header_duplicate_sp[0], txt_error_header_duplicate_sp[1], found_from_lines), found_from_lines, "From");
 		}
 		if (errors_catbp & CA_ERROR_MISSING_SUBJECT)
 			my_fprintf(stderr, _(txt_error_header_line_missing), "Subject");
 		else {
 			if (errors_catbp & CA_ERROR_DUPLICATED_SUBJECT)
-				my_fprintf(stderr, _(txt_error_header_duplicate), found_subject_lines, "Subject");
+				my_fprintf(stderr, P_(txt_error_header_duplicate_sp[0], txt_error_header_duplicate_sp[1], found_subject_lines), found_subject_lines, "Subject");
 		}
 		if (errors_catbp & CA_ERROR_MISSING_NEWSGROUPS)
 			my_fprintf(stderr, _(txt_error_header_line_missing), "Newsgroups");
 		else {
 			if (errors_catbp & CA_ERROR_DUPLICATED_NEWSGROUPS)
-				my_fprintf(stderr, _(txt_error_header_duplicate), found_newsgroups_lines, "Newsgroups");
+				my_fprintf(stderr, P_(txt_error_header_duplicate_sp[0], txt_error_header_duplicate_sp[1], found_newsgroups_lines), found_newsgroups_lines, "Newsgroups");
 		}
 
 		/* duplicated headers */
 		if (errors_catbp & CA_ERROR_DUPLICATED_FOLLOWUP_TO)
-			my_fprintf(stderr, _(txt_error_header_duplicate), found_followup_to_lines, "Followup-To");
+			my_fprintf(stderr, P_(txt_error_header_duplicate_sp[0], txt_error_header_duplicate_sp[1], found_followup_to_lines), found_followup_to_lines, "Followup-To");
 
 		/* empty headers */
 		if (errors_catbp & CA_ERROR_EMPTY_SUBJECT)
 			my_fprintf(stderr, _(txt_error_header_line_empty), "Subject");
-		if (errors_catbp & CA_ERROR_EMPTY_NEWSGROUPS && !(errors_catbp & CA_ERROR_MISSING_NEWSGROUPS))
+		if ((errors_catbp & CA_ERROR_EMPTY_NEWSGROUPS) && !(errors_catbp & CA_ERROR_MISSING_NEWSGROUPS))
 			my_fprintf(stderr, _(txt_error_header_line_empty), "Newsgroups");
 
 #ifndef ALLOW_FWS_IN_NEWSGROUPLIST
@@ -2096,13 +2122,6 @@ check_article_to_be_posted(
 		if (errors_catbp & CA_ERROR_BAD_ENCODING)
 			my_fprintf(stderr, "%s", _(txt_error_header_line_bad_encoding));
 
-		if (errors_catbp & CA_ERROR_DISTRIBUTIOIN_NOT_7BIT)
-			my_fprintf(stderr, _(txt_error_header_line_not_7bit), "Distribution");
-		if (errors_catbp & CA_ERROR_NEWSGROUPS_NOT_7BIT)
-			my_fprintf(stderr, _(txt_error_header_line_not_7bit), "Newsgroups");
-		if (errors_catbp & CA_ERROR_FOLLOWUP_TO_NOT_7BIT)
-			my_fprintf(stderr, _(txt_error_header_line_not_7bit), "Followup-To");
-
 		if (errors_catbp & CA_ERROR_BAD_MESSAGE_ID)
 			my_fprintf(stderr, _(txt_error_header_format), "Message-ID");
 		if (errors_catbp & CA_ERROR_BAD_DATE)
@@ -2156,15 +2175,22 @@ check_article_to_be_posted(
 		if (warnings_catbp & CA_WARNING_MULTI_ADDRESSES_TO)
 			my_fprintf(stderr, _(txt_warn_multiple_addresses), "To");
 
+		if (warnings_catbp & CA_WARNING_DISTRIBUTION_NOT_7BIT)
+			my_fprintf(stderr, _(txt_warning_header_line_not_7bit), "Distribution");
+		if (warnings_catbp & CA_WARNING_NEWSGROUPS_NOT_7BIT)
+			my_fprintf(stderr, _(txt_warning_header_line_not_7bit), "Newsgroups");
+		if (warnings_catbp & CA_WARNING_FOLLOWUP_TO_NOT_7BIT)
+			my_fprintf(stderr, _(txt_warning_header_line_not_7bit), "Followup-To");
+
 		if (warnings_catbp & CA_WARNING_DISTRIBUTION_WORLD)
 			my_fprintf(stderr, "%s", _(txt_warn_distribution_world));
 
 		if (warnings_catbp & CA_WARNING_MULTIPLE_SIGDASHES)
-			my_fprintf(stderr, _(txt_warn_multiple_sigs), saw_sig_dashes);
+			my_fprintf(stderr, P_(txt_warn_multiple_sigs_sp[0], txt_warn_multiple_sigs_sp[1], saw_sig_dashes), saw_sig_dashes);
 		if (warnings_catbp & CA_WARNING_WRONG_SIGDASHES)
 			my_fprintf(stderr, "%s", _(txt_warn_wrong_sig_format));
 		if (warnings_catbp & CA_WARNING_LONG_SIGNATURE)
-			my_fprintf(stderr, _(txt_warn_sig_too_long), MAX_SIG_LINES);
+			my_fprintf(stderr, P_(txt_warn_sig_too_long_sp[0], txt_warn_sig_too_long_sp[1], MAX_SIG_LINES), MAX_SIG_LINES);
 
 		if (warnings_catbp & CA_WARNING_ENCODING_EXTERNAL_INEWS)
 			my_fprintf(stderr, "%s", _(txt_warn_encoding_and_external_inews));
@@ -2186,11 +2212,12 @@ check_article_to_be_posted(
 			my_fprintf(stderr, "%s", _(txt_warn_article_unchanged));
 
 		if (ngcnt)
-			my_fprintf(stderr, _(txt_art_newsgroups), subject, PLURAL(ngcnt, txt_newsgroup));
+			my_fprintf(stderr, P_(txt_art_newsgroup_sp[0], txt_art_newsgroup_sp[1], ngcnt), subject);
 
 		if (c_art_type == GROUP_TYPE_MAIL)
 			my_fprintf(stderr, _(txt_art_mailgroups), subject, BlankIfNull(to));
 		else {
+			col = 0; /* use as moderated counter */
 			for (i = 0; i < ngcnt; i++) {
 				if ((psGrp = group_find(newsgroups[i], FALSE))) {
 					if (psGrp->aliasedto) {
@@ -2204,8 +2231,11 @@ check_article_to_be_posted(
 						my_fprintf(stderr, _(txt_warn_grp_renamed), newsgroups[i], psGrp->aliasedto);
 						++warnings;
 #endif /* HAVE_FASCIST_NEWSADMIN */
-					} else /* TODO: strunc(description)? */
-						my_fprintf(stderr, "  %s\t %s\n", newsgroups[i], BlankIfNull(psGrp->description));
+					} else { /* TODO: strunc(description)? */
+						my_fprintf(stderr, "%c  %s\t %s\n", group_flag(psGrp->moderated), newsgroups[i], BlankIfNull(psGrp->description));
+						if (psGrp->moderated == 'm')
+							++col;
+					}
 				} else {
 #ifdef HAVE_FASCIST_NEWSADMIN
 					StartInverse();
@@ -2222,12 +2252,12 @@ check_article_to_be_posted(
 			if (!found_followup_to_lines && ngcnt > 1 && !errors) {
 #ifdef HAVE_FASCIST_NEWSADMIN
 				StartInverse();
-				my_fprintf(stderr, _(txt_error_missing_followup_to), ngcnt);
+				my_fprintf(stderr, P_(txt_error_missing_followup_to_sp[0], txt_error_missing_followup_to_sp[1], ngcnt), ngcnt);
 				EndInverse();
 				my_fflush(stderr);
 				++errors;
 #else
-				my_fprintf(stderr, _(txt_warn_missing_followup_to), ngcnt);
+				my_fprintf(stderr, P_(txt_warn_missing_followup_to_sp[0], txt_warn_missing_followup_to_sp[1], ngcnt), ngcnt);
 				++warnings;
 #endif /* HAVE_FASCIST_NEWSADMIN */
 			}
@@ -2246,9 +2276,10 @@ check_article_to_be_posted(
 #endif /* HAVE_FASCIST_NEWSADMIN */
 				}
 #ifdef HAVE_FASCIST_NEWSADMIN
-				if (!errors) {
+				if (!errors)
 #endif /* HAVE_FASCIST_NEWSADMIN */
-					my_fprintf(stderr, _(txt_followup_newsgroups), PLURAL(ftngcnt, txt_newsgroup));
+				{
+					my_fprintf(stderr, "%s", P_(txt_followup_newsgroup_sp[0], txt_followup_newsgroup_sp[1], ftngcnt));
 					for (i = 0; i < ftngcnt; i++) {
 						if ((psGrp = group_find(followupto[i], FALSE))) {
 							if (psGrp->aliasedto) {
@@ -2263,7 +2294,7 @@ check_article_to_be_posted(
 								++warnings;
 #endif /* HAVE_FASCIST_NEWSADMIN */
 							} else /* TODO: strunc(description)? */
-								my_fprintf(stderr, "  %s\t %s\n", followupto[i], BlankIfNull(psGrp->description));
+								my_fprintf(stderr, "   %s\t %s\n", followupto[i], BlankIfNull(psGrp->description));
 						} else {
 							if (STRCMPEQ("poster", followupto[i]))
 								my_fprintf(stderr, _(txt_followup_poster), followupto[i]);
@@ -2281,9 +2312,36 @@ check_article_to_be_posted(
 							}
 						}
 					}
-#ifdef HAVE_FASCIST_NEWSADMIN
 				}
-#endif /* HAVE_FASCIST_NEWSADMIN */
+			}
+
+			if (col) { /* any moderated groups? */
+				my_fprintf(stderr, "\n");
+				if (ngcnt > 1)
+					my_fprintf(stderr, P_(txt_warn_groups_moderated_sp[0], txt_warn_groups_moderated_sp[1], col), col);
+				else
+					my_fprintf(stderr, "%s", _(txt_warn_group_is_moderated));
+			}
+
+			if (dist && *dist) {
+				char *d, *dc, *s;
+				t_distrib_pat *p, *q;
+
+				my_fprintf(stderr, "%s", _(txt_warn_distribution));
+				s = dc = my_strdup(dist);
+				while ((d = strtok(s, ", \t")) != NULL) {
+					for (p = nntp_caps.distrib_pats; p != NULL; p = q) {
+						if (!strcasecmp(p->distribution, d)) {
+							my_fprintf(stderr, "   %s\t %s\n", p->distribution, BlankIfNull(p->description));
+							break;
+						}
+						q = p->next;
+					}
+					s = NULL;
+					if (p == NULL)
+						my_fprintf(stderr, "   %s\n", d);
+				}
+				free(dc);
 			}
 
 #ifndef NO_ETIQUETTE
@@ -2294,10 +2352,10 @@ check_article_to_be_posted(
 		}
 	}
 	fclose(fp);
-
 	Raw(oldraw);		/* restore raw/unraw state */
 
 	/* free memory */
+	FreeIfNeeded(dist);
 	if (newsgroups && ngcnt) {
 		FreeIfNeeded(*newsgroups);
 		FreeIfNeeded(newsgroups);
@@ -2435,7 +2493,7 @@ post_loop(
 	char a_message_id[HEADER_LEN];	/* Message-ID of the article if known */
 	int ret_code = POSTED_NONE;
 	int i = 1;
-	int save_signal_context = signal_context;
+	enum context save_signal_context = signal_context;
 	long artchanged;		/* artchanged work was not done in post_postponed_article */
 	struct t_group *ogroup = curr_group;
 	t_bool art_unchanged;
